unit UnitClipMenuInfo;

{
    purpose:
    This is mainly used by a Popup to store info about the last selected menu item

    notes:
    the main usage is for the Clip Menu or Scripts to get information about the selected clip
}
interface

uses UnitMenuItemTagdata, UnitClipQueue, UnitACPopupPrototype;


type TLastClipMenuInfo = class
    private
        class var fItemType : TItemType;
        class var fClip : TClipItem;
        class var fIntegerData : integer;
    public
        class procedure ExtractPopupItemData( p : TACPopupItem );

        class property ItemType : TItemType read fItemType;
        class property Clip : TClipItem read fClip;
        class property IntegerData : integer read fIntegerData;
end;

implementation


class procedure TLastClipMenuInfo.ExtractPopupItemData( p : TACPopupItem );
begin
    fItemType := p.ItemType;
    fClip := p.Clip;
    fIntegerData := p.IntegerData;
end;


end.
